#ifndef BASIC_OBJECTS_H
#define BASIC_OBJECTS_H

#include "Object.h"
#include "ObjectAddon.h"

// BLOODY MESS

class BloodyMess : public Object
{
	public:
		BloodyMess();
		virtual ~BloodyMess();
};

class BloodyMessInfo : public ObjectInfo
{
	public:
		BloodyMessInfo();
		
		virtual Object * Create();
		virtual bool ShouldPlace( int );
		
	protected:
		bitmap_info		bmp[2];
};

// HEALTH POTION

class HealthPotion : public Object
{
	public:
		HealthPotion();
		virtual ~HealthPotion();
		
		virtual void Use( Creature *, Creature * );
		
		uint32 empty_id;
		
		virtual status_t Save( BFile * );
		virtual status_t Load( BFile * );
		
	private:
		bool used;
};

class HealthPotionInfo : public ObjectInfo
{
	public:
		HealthPotionInfo();
		
		virtual Object * Create();

	protected:
		bitmap_info		bmp[3];
};

// SWORD

class Sword : public Object
{
	public:
		Sword();
		virtual ~Sword();
		
		virtual void Use( Creature *, Creature * );
};

class SwordInfo : public ObjectInfo
{
	public:
		SwordInfo();
		
		virtual Object * Create();
		virtual bool ShouldPlace( int );

	protected:
		bitmap_info		bmp[2];
};

// BASIC OBJECT BUILDER

class BasicObjectBuilder : public ObjectBuilder
{
	public:
		BasicObjectBuilder();
	
	protected:
		HealthPotionInfo	health_info;
		BloodyMessInfo		mess_info;
		SwordInfo			sword_info;
		
		ObjectInfo			* info_original[4];
};

extern "C" __declspec(dllexport) ObjectBuilder * CreateObjectBuilder();

#endif
